Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports Syncfusion.Windows.Forms.Grid
Imports System.Diagnostics
Imports DropdownGrid


Namespace GDBG
	Partial Public Class Form1
		Inherits Form
		Public Sub New()
			InitializeComponent()
		End Sub


		Private grid As GridDataBoundGrid
		Private list As DataTable

		Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
			Dim dt As DataTable= GetTable()
			Me.gridDataBoundGrid1.DataSource = GetParentTable()
			Dim dv As DataView = (CType(Me.gridDataBoundGrid1.DataSource, DataTable)).DefaultView
            dv.RowFilter = "[ParentId]=''"
			Me.gridDataBoundGrid1.Binder.EnableAddNew = False


			Dim model As New DropDownGridCellModel(Me.gridDataBoundGrid1.Model)
			grid= New GridDataBoundGrid()
			model.EmbeddedGrid = grid
			Me.gridDataBoundGrid1.Model.CellModels.Add("GridDrop", model)
			list = GetTable1()
			grid.DataSource = GetChildTable()
			grid.Binder.EnableAddNew = False

			Me.gridDataBoundGrid1.RefreshRange(GridRangeInfo.Row(1))

			AddHandler gridDataBoundGrid1.CurrentCellShowingDropDown, AddressOf gridDataBoundGrid1_CurrentCellShowingDropDown
			AddHandler gridDataBoundGrid1.PrepareViewStyleInfo, AddressOf gridDataBoundGrid1_PrepareViewStyleInfo

			Dim colu As GridBoundColumnsCollection = TryCast(Me.gridDataBoundGrid1.Binder.InternalColumns.Clone(), GridBoundColumnsCollection)
			Dim co As New GridBoundColumn()
			co.HeaderText = ""
			colu.Insert(0, co)
			Me.gridDataBoundGrid1.Binder.GridBoundColumns = colu
			Me.gridDataBoundGrid1.Model.HideCols(0) = True
		End Sub

		Private Sub gridDataBoundGrid1_PrepareViewStyleInfo(ByVal sender As Object, ByVal e As GridPrepareViewStyleInfoEventArgs)
			If e.ColIndex = 1 AndAlso e.RowIndex > 0 Then
				e.Style.CellType = "GridDrop"
				e.Cancel = True
			End If
		End Sub


		Private Sub gridDataBoundGrid1_CurrentCellShowingDropDown(ByVal sender As Object, ByVal e As GridCurrentCellShowingDropDownEventArgs)
			Dim dv As DataView = (CType(Me.grid.DataSource, DataTable)).DefaultView
			dv.RowFilter = "[ParentId]=" & Me.gridDataBoundGrid1(Me.gridDataBoundGrid1.CurrentCell.RowIndex, 2).Text
		End Sub

		Private parentRows As Integer = 10
		Private ChildRows As Integer = 30

		Private Function GetParentTable() As DataTable
			Dim dt As New DataTable("ParentTable")

			dt.Columns.Add(New DataColumn("parentID")) 'lower case p
			dt.Columns.Add(New DataColumn("ParentName"))

			For i As Integer = 0 To parentRows - 1
				Dim dr As DataRow = dt.NewRow()
				dr(0) = i.ToString()
				dr(1) = String.Format("parentName{0}", i)
				dt.Rows.Add(dr)
			Next i

			Return dt
		End Function
		Private r As New Random()

		Private Function GetChildTable() As DataTable
			Dim dt As New DataTable("ChildTable")

			dt.Columns.Add(New DataColumn("childID")) 'lower case c
			dt.Columns.Add(New DataColumn("Name"))
			dt.Columns.Add(New DataColumn("ParentID")) 'upper case P

			For i As Integer = 0 To ChildRows - 1
				Dim dr As DataRow = dt.NewRow()
				dr(0) = i.ToString()
				dr(1) = String.Format("ChildName{0}", i)
				dr(2) = r.Next(parentRows).ToString() '(i % parentRows).ToString();
				dt.Rows.Add(dr)
			Next i

			Return dt
		End Function

		Public Function GetTable() As DataTable
			Dim dt As New DataTable("Details")
			dt.Columns.Add(New DataColumn("IDs&names",GetType(String)))
			dt.Columns.Add(New DataColumn("Values"))

			Dim r As New Random()
			For i As Integer = 0 To 4
				Dim dr As DataRow = dt.NewRow()
				dr(0) = i + 1
				dr(1) = r.Next(200, 300)
				dt.Rows.Add(dr)
			Next i
			Return dt
		End Function

		Public Function GetTable1() As DataTable
			Dim dt As New DataTable("Details")
			Dim nRows As Integer = 5
			dt.Columns.Add(New DataColumn("Id"))
			dt.Columns.Add(New DataColumn("Name"))

			Dim r As New Random()
			For i As Integer = 0 To nRows - 1
				Dim dr As DataRow = dt.NewRow()
				dr(0) = i + 1
				dr(1) = "Name" & (i + 1)
				dt.Rows.Add(dr)
			Next i
			Return dt
		End Function

		Private Sub button1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles button1.Click
			Dim dv As DataView = (CType(Me.gridDataBoundGrid1.DataSource, DataTable)).DefaultView
			dv.RowFilter = "[ParentId]=" & Me.textBox1.Text
		End Sub
	End Class
End Namespace